#include "local.h"

#define DONE 1

void convert()
{ 
 int bksp, line, newline_pos, length, i;
 int version=0, well_info=0;
 static char buffer[MAX_LINE_LENGTH];
 char type[11]; 
 char line_out[MAX_LINE_LENGTH];
 char *temp;
 char front[MAX_LINE_LENGTH], middle[MAX_LINE_LENGTH], end[MAX_LINE_LENGTH];
 double vers_check, vers;

 
/* 
   The program will; 
   - convert LAS 1.2 to LAS 2.0
 */ 

  temp = (char *)malloc(MAX_LINE_LENGTH);
  line = 0;
  fprintf(stdout,"You have chosen to convert from LAS version 1.2 to 2.0.\n");
  fprintf(stdout,"Scanning line       ");
 

 /* Read through the file copying to the output until the ~W section is
    reached.    */

 do 
 { 
  if (fgetsup(buffer,MAX_LINE_LENGTH,ip) == NULL)
  { 
   fprintf(stdout,"\nCannot read from input file. Run terminated\n");
   return;

  } 
  else 
  { 
   line++; 
   for (bksp = 1; bksp < 7; bksp++) 
    fprintf(stdout,"%c",8); 
   fprintf(stdout,"%6d",line); 
   fflush (stdout);
   strset(type,'\0'); 
   sscanf(buffer, "%8s", type); 

  /* Check for the  version information */

    if(strncmp(type,"VERS",4) == 0)
    {
     sscanf(buffer, "%*s%lf", &vers);

     if (vers <=1.19)
     {
      fprintf(stdout,"\nWarning: this file claims to be LAS version %lf.\n",vers);
      fprintf(stdout,"         Version 1.2 was the first public release\n");
      fprintf(stdout,"         Conversion will be attempted anyway...\n");
     }

     if (vers >= 1.21)
     {
      fprintf(stdout,"\nError:   This file claims to be LAS version %lf.\n",vers);
      fprintf(stdout,"         This utility converts LAS 1.2 to LAS 2.0\n");
      fprintf(stdout,"         Conversion cancelled.\n");
      return;

     }

     /* Check that there is a period separating the VERS from the number */

     temp = strstr(buffer, ".");
     sscanf(temp+1, "%lf", &vers_check);
     if (vers_check != vers)
     {
      fprintf(stdout,"\nERROR: VERS line in ~V section does not have \n");
      fprintf(stdout,"       a period separator between VERS and value\n");
      return;

     }

     /* Version is okay for conversion.  Output updated line */

     fprintf(op, " VERS.   2.0    : CWLS LOG ASCII STANDARD - VERSION 2.0 \n");
     version = DONE;
     continue;
    }

  /* Check for the  ~W flag */

   if(type[0] == '~' && type[1] == 'W')
   {
    status=fputs(buffer,op);
    if ((status == EOF)||(status < 0))
    {
     fprintf(stdout,"\nCannot write to output file. Run terminated\n");
     return;

    }

    while (fgetsup (buffer,MAX_LINE_LENGTH,ip) != NULL)
    {
     line++;
     for (bksp = 1; bksp < 7; bksp++)
      fprintf(stdout,"%c",8);
     fprintf(stdout,"%6d",line);
     fflush (stdout);
     strset(type,'\0');
     sscanf(buffer, "%8s", type);

     /* If another tilde is found, we have finished the ~W section. */

     if(type[0] == '~')
     {
      well_info = DONE;
      break;
     }
     /* Ignore everything except the required lines */

     if(strncmp(type,"COMP",4) != 0 &&
	strncmp(type,"WELL",4) != 0 &&
	strncmp(type,"FLD",4) != 0 &&
	strncmp(type,"FLD.",4) != 0 &&
	strncmp(type,"LOC",4) != 0 &&
	strncmp(type,"LOC.",4) != 0 &&
	strncmp(type,"PROV",4) != 0 &&
	strncmp(type,"CNTY",4) != 0 &&
	strncmp(type,"STAT",4) != 0 &&
	strncmp(type,"CTRY",4) != 0 &&
	strncmp(type,"DATE",4) != 0 &&
	strncmp(type,"UWI",4) != 0 &&
	strncmp(type,"API",4) != 0 &&
	strncmp(type,"UWI.",4) != 0 &&
	strncmp(type,"API.",4) != 0 &&
	strncmp(type,"SON.",4) != 0 &&
	strncmp(type,"SON",4) != 0 &&
	strncmp(type,"SRVC",4) != 0)
     {
      status=fputs(buffer,op);
      if ((status == EOF)||(status<0))
      {
       fprintf(stdout,"\nCannot write to output file. Run terminated\n");
       return;
      }
      continue;
     }


  /* Otherwise parse the line and flip the middle and end. */

     sscanf(buffer, "%[^.]", front);
     temp = strchr(buffer, '.');
     length = strlen(temp);
     for (i=1; i < length; i++)
      if (temp[i] != ' ') break;
     sscanf(temp+i, "%[^:]", middle);
     temp = strchr(buffer, ':');
     strcpy(end, temp+1);

     strset(line_out, '\0');
     newline_pos = strlen(end);
     end[newline_pos - 2] = '\0';
     sprintf(line_out, "%s.  %-40s: %s  %c%c", front, end, middle, 13, 10);

     status=fputs(line_out,op);
     if ((status == EOF)||(status<0))
     {
      fprintf(stdout,"\nCannot write to output file. Run terminated\n");
      return;
     }
    }
   }

   /* The current line is not to be converted. Copy to output file. */
   status=fputs(buffer,op);
   if ((status == EOF)||(status<0))
   {
    fprintf(stdout,"\nCannot write to output file. Run terminated\n");
    return;
   }
  } 
 } 
  while (!version || !well_info);
 
/* The conversion is done. Copy the rest of the file to the output.  */

  while (fgets(buffer,MAX_LINE_LENGTH,ip) != NULL)
  {
   line++;
   for (bksp = 1; bksp < 7; bksp++)
    fprintf(stdout,"%c",8);
   fprintf(stdout,"%6d",line);
   fflush (stdout);
   status=fputs(buffer,op);
   if ((status == EOF)||(status<0))
   {
    fprintf(stdout,"\nCannot write to output file. Run terminated\n");
    return;
   }
  }
  fprintf(stdout,"\nREFORMAT(CONVERSION LAS 1.2 to LAS 2.0) COMPLETE\n");
}
