#include "local.h"

void depth()
{ 
 int bksp, entry;
 long line;
 int start_ok, stop_ok;
 double new_start, new_stop, depth, minimum, maximum;
 static char buffer[MAX_LINE_LENGTH];
 char type[10]; 
 char leader[80]; 

/*
   The program will; 
   - extract specific depth intervals 
 */ 
 
/* Ask the user for the desired depth interval */ 
 
 line = 0;
 start_ok = stop_ok = 0;
 do
 { 
  fprintf(stdout,"You have chosen to extract a specific depth interval.\n"); 
  fprintf(stdout,"Your input file %s currently has this range:\n\n",infile); 
  fprintf(stdout," STARTING DEPTH : %lf\n",start);
  fprintf(stdout,"   ENDING DEPTH : %lf\n",stop);
  fprintf(stdout,"     DEPTH STEP : %lf\n\n\n\n\n\n",step);

  fprintf(stdout,"Please enter the new starting depth [%lf]:  ",start);
  /* fflush(stdin); */
  fgets(buffer,80,stdin);
  if (sscanf(buffer, "%lf", &new_start) != 1)
   new_start = start;

  fprintf(stdout,"\n\nPlease enter the new ending depth [%lf]:  ",stop);
  /* fflush(stdin); */
  fgets(buffer,80,stdin);
  if (sscanf(buffer, "%lf", &new_stop) != 1)
   new_stop = stop;

  fprintf(stdout,"\n"); 
 
  /* Check that the values given are the right way around  */ 
 
  entry = BAD; 
 
  if (new_start > new_stop && step <= 0.0)
    entry = OK; 
 
  if (new_start < new_stop && step >= 0.0)
    entry = OK; 
 
  if (step > 0.0)
  { 
   if (new_start < start || new_start > stop) 
   entry = BAD; 
   if (new_stop > stop || new_stop < start) 
   entry = BAD; 
  } 
  else 
  { 
   if (new_start > start || new_start < stop) 
   entry = BAD; 
   if (new_stop < stop || new_stop > start) 
   entry = BAD; 
  } 
 
  if (entry != OK) 
  { 
   fprintf(stdout,"Your start, stop or step values are invalid. See above.\n"); 
   pause(); 
  } 
  clear_screen(); 
 } while (entry == BAD); 

 /* Ensure the start and stop values are even multiples of a step */

 new_start = start + (step * floor(fabs((new_start-start) / step)));
 new_stop  = start + (step * floor(fabs((new_stop-start) / step)));

 /* Read through the file copying to the output until the depths are 
    reached. En route check for the start, stop and step values as 
    these have to be flipped.                                      */ 
 
 fprintf(stdout,"Scanning line      \n");
 do
 { 
  if (fgetsup(buffer,MAX_LINE_LENGTH,ip) == NULL)
  { 
   fprintf(stdout,"Cannot read from input file. Run terminated\n"); 
   return;

  } 
  else
  {
   line++;
   for (bksp = 1; bksp < 7; bksp++) 
    fprintf(stdout,"%c",8); 
   fprintf(stdout,"%ld",line);
   fflush(stdout);
   strset(type,'\0'); 
   sscanf(buffer, "%8s", type); 
 
   /* Check for start, stop and step */ 
 
   if(strncmp(type,"STRT",4) == 0 || strncmp(type,"STOP",4) == 0) 
   { 
    strset(leader,'\0'); 
    if(strncmp(type,"STRT",4) == 0) 
    { 
     sscanf(buffer, "%[^-1234567890]", leader); 
     fprintf(op,"%s%lf:\n",leader,new_start);
    }
 
    if(strncmp(type,"STOP",4) == 0) 
    { 
     sscanf(buffer, "%[^-1234567890]", leader); 
     fprintf(op,"%s%lf:\n",leader,new_stop);
    }
   } 
   else 
   {
    status=fputs(buffer,op);
    if ((status == EOF)||(status<0))
    {
     fprintf(stdout,"Cannot write to output file. Run terminated\n"); 
     return;
    }
   }
  } 
 } 
  while (strncmp(type,"~A",2) != 0); 
 
/* Now output the depth values that are within the specified range */ 
 
  while (fgets (buffer,MAX_LINE_LENGTH,ip) != NULL)
  {
   line++;
   for (bksp = 1; bksp < 7; bksp++) 
    fprintf(stdout,"%c",8);
   fprintf(stdout,"%ld",line);
   fflush(stdout);
   sscanf(buffer,"%lf",&depth);

   /* Expand the limits by a wee bit to allow for double to double equality */
   /* checks.  Otherwise an occasional value will slip through even though  */
   /* its really equal to the limit.                                        */

   minimum =  min(new_start, new_stop) - 0.000001;
   maximum =  max(new_start, new_stop) + 0.000001;
   if (depth >= minimum && depth <= maximum)
   if (depth >= minimum && depth <= maximum)
   {
    status=fputs(buffer,op);
    if ((status == EOF)||(status<0))
    {
     fprintf(stdout,"Cannot write to output file. Run terminated\n"); 
     return;
    }
   }
  } 
 fprintf(stdout,"\nREFORMAT(DEPTH SELECTION) COMPLETED\n");
 return;
}


