/* Compile with CL /AL /Gt20 reformat.c /F d6d8 */
#define EGSTERN
#include "local.h"
/*
#define DOS 1
#define UNIX 2
#define HOST DOS

#include <dos.h>
#include <conio.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <ctype.h>
#include <malloc.h>

#define COEFLEN 999
#define CTRLZ 26
#define OK 1
#define BAD 0
#define MAX_SAMPLES 20000         //max samples
#define PI 4.0 * atan(1.0)
#define TWOPI 8.0 * atan(1.0)
#define YES 0
#define NO 1
#define ALPHA 0.5
#define BETA 0.5
FILE *fp, *ip, *op;

double start, stop, step, las_null;
char infile[80], outfile[80];
int status;
double huge big_temp[MAX_SAMPLES];
double huge data[2][MAX_SAMPLES];

char *fgetsup(char *, int, FILE *);
void clear_screen(void);
void pause(void);
void check(void), depth(void), curve(void), reverse(void);
void resamp(void), unwrap(void), convert(void);
void main(int, char**);
*/

void main(argc, argv)
int argc;
char *argv[];
{

/* This program was written August 1989 by Robin W. Winsor of Gulf Canada 
    Resources Limited.  It is intended for use with files written to the 
    C.W.L.S. Log File Standard. It is written in ANSI standard C and has 
    been compiled with the Microsoft C5.1 compiler. 
 
 October 1990.
    Revision 2.0 fixes a bug in the resample option.
 June 1992.
    Revision 2.1 fixes a minor bug (stop depth) in the resample option.
 August 1992
    Revision 2.2 upgrade to handle LAS version 2.0 and convert 1.2 to 2.0.
 February 1993
    Revision 2.3 bug fix for header records longer than 80 characters when
    unwrapping.
 May 1995
    Revision 2.50 fixes bugs in resample,reverse,curve
    -reverse,curve,depth,are now able to handle lines up 1200 characters
    -resample is able to handle inputs up to 10,000 lines, outputs up to
     49999 lines, and lines lengths up to 600 characters long.

 
    This software may be freely copied and distributed.  The author does 
    not reserve any rights, and does not warrant the program fit for any 
    specific purpose. 
 
   The program will; 
   - extract specific depth intervals 
   - extract specific curves 
   - resample the depth increment 
   - reverse the order of the data 
   - unwrap data from 80 col wrap mode 
   - scan for non_ascii or unprintable data
   - convert from version 1.2 to 2.0
 
                        */ 
 
 char buffer[MAX_LINE_LENGTH]; 
 char type[10]; 
 int answer, entry; 
 int i, wrap_mode, max_length, inlen, outlen;
 int section_v, section_w, section_c, different_files;
 
 /* get the user to specify the input and output files */ 
 
 do 
 { 
  clear_screen(); 
  fprintf(stdout,"                CANADIAN WELL LOGGING SOCIETY \n"); 
  fprintf(stdout,"                      REFORMAT UTILITY        \n"); 
  fprintf(stdout,"                        VERSION 2.51      \n\n\n");
  fprintf(stdout," This program was designed to manipulate LAS formatted files.\n\n"); 
  fprintf(stdout," Any comments concerning this program should be addressed to:\n"); 
  fprintf(stdout,"  C.W.L.S. Floppy Disk Committee  \n"); 
  fprintf(stdout,"  Suite 229, 640 - 5th Avenue, S.W. \n"); 
  fprintf(stdout,"  Calgary, Alberta  T2P 0M6\n"); 
  fprintf(stdout,"  Canada\n\n"); 
  fprintf(stdout," No rights reserved. This program is not warranted to be fit\n");
  fprintf(stdout," for any specific purpose and does not constitute a part of the\n");
  fprintf(stdout," LAS standard itself.  In case of difficulty, confirm that your\n");
  fprintf(stdout," input file meets the LAS standard by running the CERTIFY utility,\n");
  fprintf(stdout," or LAS for Windows also available from the C.W.L.S.\n");
  fprintf(stdout," \n\n\n");
  fprintf(stdout,"Please enter the name  of the input file: ");
  if (argc > 1)
  {
   strcpy(infile, argv[1]);
   fprintf(stdout,"%s\n", argv[1]);
  }
  else
   if ( NULL == gets(infile) ) exit(1);

  if (strstr(infile, ".") == NULL)       /* tack on the extension by default  */
   strcat(infile, ".las");

  fprintf(stdout,"\nPlease enter the name of the output file: ");
  if (argc > 2)
  {
   strcpy(outfile, argv[2]);
   fprintf(stdout,"%s\n", argv[2]);
  }
  else {
    fflush(stdout);
    if ( NULL == gets(outfile) ) exit(1);
  }

  if (strstr(outfile, ".") == NULL)       /* tack on the extension by default  */
   strcat(outfile, ".las");
 
  inlen = strlen(infile); 
  outlen = strlen(outfile); 
  different_files = YES; 
  if (inlen == outlen) 
  { 
   different_files = NO; 
   for(i = 0; i < inlen; i++) 
   { 
    if(toupper(infile[i]) != toupper(outfile[i])) 
    { 
     different_files = YES; 
     break; 
    } 
   } 
  } 
  if (different_files == NO) 
  { 
   fprintf(stdout,"\n\n ERROR: YOUR INPUT AND OUTPUT FILES ARE THE SAME. \n"); 
   pause(); 
  } 
 } while(different_files == NO); 
 
 /* Open the input and output files */ 
 
 if ((ip = fopen(infile,"r")) == NULL)
 { 
  fprintf(stdout,"Unable to open input file. Run terminated\n"); 
  return;
 } 
 if ((fp = fopen(infile,"r")) == NULL)
 { 
  fprintf(stdout,"Unable to open input file. Run terminated\n"); 
  return;
 } 
 if ((op = fopen(outfile,"w")) == NULL)
 {
  fprintf(stdout,"Unable to open output file. Run terminated\n");
  return;
 }
 
 /*  Now scan the input file for the start, stop and step values. This 
     is repeated for most of the reformatting options but is done here 
     using a different file pointer so that the information about the 
     input file can be displayed to the user prior to her entering her 
     choices. 
 */ 
 section_v = BAD;
 section_w = BAD;
 section_c = BAD;
 
 do 
 { 
  if (fgetsup (buffer,256,fp) == NULL) 
  { 
   if (feof(fp) == 0) 
   { 
    fprintf(stdout,"Cannot read from input file. Run terminated\n"); 
    return;
   }
   else 
   { 
    fprintf(stdout,"End of file reached without encountering the ~A section.\n"); 
    fprintf(stdout,"Check that file %s is LAS format. Run terminated\n",infile); 
    return;
   } 
  }
  else 
  { 
   strset(type,'\0'); 
   sscanf(buffer, "%8s", type); 
 
  /* Check the necessary ~ flags are present */ 
 
   if(type[0] == '~') 
   { 
    if (type[1] == 'V') 
      section_v = OK; 
    if (type[1] == 'W') 
      section_w = OK; 
    if (type[1] == 'C') 
      section_c = OK; 
   } 
 
   /* Check for start, stop and step */ 
 
   if(strncmp(type,"STRT",4) == 0)                 
   {
      if (type[4] == '.')
         sscanf(buffer, "%*s%lf", &start);
      else
         sscanf(buffer, "%*s %*s%lf", &start);
   }
 
   if(strncmp(type,"STOP",4) == 0) 
   {
      if (type[4] == '.')
         sscanf(buffer, "%*s%lf", &stop);
      else
         sscanf(buffer, "%*s %*s%lf", &stop);
   }
 
   if(strncmp(type,"STEP",4) == 0) 
   {
      if (type[4] == '.')
         sscanf(buffer, "%*s%lf", &step);
      else
         sscanf(buffer, "%*s %*s%lf", &step);
   }
 
   if(strncmp(type,"NULL",4) == 0) 
   {
      if (type[4] == '.')
         sscanf(buffer, "%*s%lf", &las_null);
      else
         sscanf(buffer, "%*s %*s%lf", &las_null);
   }
 
   /* check for wrap or unwrap mode */ 
 
   if(strncmp(type,"WRAP",4) == 0) 
   { 
    if (strstr(buffer,"YES") != NULL) 
     wrap_mode = YES; 
    else 
     wrap_mode = NO; 
   } 
 
  }
 } 
  while (strncmp(type,"~A",2) != 0); 
 
  /* read the first ten data lines to check the line length */
 
 max_length = 0;
 for (i=0; i < 3; i++)
 { 
  fgets (buffer,MAX_LINE_LENGTH,fp); 
  if (strlen(buffer) > max_length)
  max_length = strlen(buffer);
 } 
 if (wrap_mode == YES && max_length > 80)
 {
  clear_screen();
  fprintf(stdout,"Line length including carriage return / line feed exceeds \n");
  fprintf(stdout,"80 characters yet the header indicates wrap mode.\n");
  fprintf(stdout,"Check that file %s is LAS format. Run terminated\n",infile);
  return;

 }
 
 /* Ensure we did find the required ~ flags before proceeding */ 
 
 if (section_v != OK) 
 { 
  fprintf(stdout,"The ~V section required by the LAS format is not present.\n"); 
  fprintf(stdout,"Check that file %s is LAS format. Run terminated\n",infile); 
  return;

 } 
 if (section_w != OK) 
 { 
  fprintf(stdout,"The ~W section required by the LAS format is not present.\n"); 
  fprintf(stdout,"Check that file %s is LAS format. Run terminated\n",infile); 
  return;
 } 
 if (section_c != OK) 
 { 
  fprintf(stdout,"The ~C section required by the LAS format is not present.\n"); 
  fprintf(stdout,"Check that file %s is LAS format. Run terminated\n",infile); 
  return;
 } 
 
 do 
 { 
  clear_screen(); 
  fprintf(stdout,"Please select a reformatting operation from the list below.\n"); 
  if (wrap_mode == NO && max_length < MAX_LINE_LENGTH)
    fprintf(stdout,"    1 - Extract a depth interval \n\n"); 
  else
    {
    if (wrap_mode == YES)
    fprintf(stdout,"    1 - Unavailable. File in wrap mode \n\n"); 
    else
    fprintf(stdout,"    1 - Unavailable. Line length exceeds %d characters. \n\n",MAX_LINE_LENGTH);
    }
  if ((wrap_mode == NO )&& (max_length < MAX_LINE_LENGTH))
    fprintf(stdout,"    2 - Extract one or more curves\n\n"); 
  else
    {
    if(wrap_mode == YES)
    fprintf(stdout,"    2 - Unavailable. File in wrap mode  \n\n");
    else
    fprintf(stdout,"    2 - Line length exceeds %d characters\n\n",MAX_LINE_LENGTH);
    }
  if (wrap_mode == NO && max_length < MAX_LINE_LENGTH)
    fprintf(stdout,"    3 - Reverse the depth direction \n\n"); 
  else
    {
    if (wrap_mode == YES)
    fprintf(stdout,"    3 - Unavailable. File in wrap mode \n\n"); 
    else
    fprintf(stdout,"    3 - Unavailable. Line length exceeds %d characters. \n\n",MAX_LINE_LENGTH);
    }
  if (wrap_mode == NO && max_length < (MAX_LINE_LENGTH/2) && step != 0L)
    fprintf(stdout,"    4 - Change the depth step (i.e. increment)\n\n");
  else
    {
    if (step == 0L)
    fprintf(stdout,"    4 -  Unavailable. Step of 0 indicates variable step file. \n\n");
    else
	{
        if (wrap_mode == YES) 
          fprintf(stdout,"    4 - Unavailable. File in wrap mode \n\n"); 
        else 
	  fprintf(stdout,"    4 - Unavailable. Line length exceeds %d characters. \n\n",(MAX_LINE_LENGTH/2));
	}
    }
 
  if (wrap_mode == YES) 
    fprintf(stdout,"    5 - Convert wrap to unwrap mode\n\n"); 
  else 
    fprintf(stdout,"    5 - Unavailable. File not in wrap mode \n\n"); 
 
  fprintf(stdout,"    6 - Scan for non-standard characters\n\n");

  fprintf(stdout,"    7 - Convert LAS 1.2 to 2.0   \n\n");

  fprintf(stdout,"    8 - Convert LAS 2.0 to 1.2   \n\n\n\n");

  fprintf(stdout,"    Option: "); 
  fgets(buffer,80,stdin);
  sscanf(buffer,"%d",&answer); 
  fprintf(stdout,"\n"); 
 
  /* Validate the reply  */ 
 
  entry = OK; 
  if (answer < 1 || answer > 8)
    entry = BAD; 
  if (wrap_mode == YES && answer < 5)
    entry = BAD; 
  if (wrap_mode == NO && answer == 5) 
    entry = BAD; 
  if (max_length > MAX_LINE_LENGTH && (answer == 1 || answer == 3 || answer == 2))
    entry = BAD;
  if (max_length > (MAX_LINE_LENGTH/2) && (answer == 4 ))
    entry = BAD;

  if (entry == BAD)
  { 
   fprintf(stdout,"Invalid option picked. Please try again or Ctrl C to quit\n"); 
   fflush(stdout);
   pause(); 
  } 
 } 
 while (entry != OK); 
 
/* Call the appropriate function  */

 switch (answer) 
 { 
  case 1: 
    clear_screen(); 
           depth(); 
	   break;
  case 2: 
    clear_screen(); 
    curve(); 
           break; 
  case 3: 
    clear_screen();
           reverse(); 
           break; 
  case 4: 
    clear_screen(); 
      resamp(); 
      break;
  case 5: 
    clear_screen(); 
      unwrap(); 
      break; 
  case 6:
    clear_screen();
      check();
      break;
  case 7:
    clear_screen();
      convert();
      break;
  case 8:
    clear_screen();
      convert_a();
      break;

 } 
 fclose(ip);
 fclose(fp);
 fclose(op);
 exit(0);
}

char *fgetsup(string,n,stream)
char *string;
int n;
FILE *stream;
{
 int length,i;
 char *result;
 static char last_tilde;

 result = fgets(string,n,stream);
 length = strlen(string);

 /* Convert each character to uppercase except when the previous character
    is a tilde (~). This is to ensure case sensitive checking of the ~
    control sections.    */

 if (islower(string[0]))
  string[0] = toupper(string[0]);
 for (i=1; i < length; i++)
 {
   if (string[i-1] == '~' && isupper(string[i]))
    last_tilde = string[i];

   if (islower(string[i]) && string[i-1] != '~' && last_tilde != 'O')
      string[i] = toupper(string[i]);
 }

 return(result);
}

void pause()
{
 fprintf(stdout,"Please hit any key to continue.\n");
 getch();
}

void clear_screen()
{
#ifdef _dos
 system("cls");
#else
 system("clear");
#endif
}
