#include "local.h"
int mod(int, int);
void filter(int, double *);
void convolve(double huge *, double *, int, int);


void resamp()
{

  long bksp, line, first_data_line, i, curves=0, current_curve, bad;
  long out_line;
  long entry, filter_length, curve_length, line_length, num_of_lines;
 int output_drive;
 int filter_reqd,the_end;
 int length,ic;
 char soup[30];
#ifdef _dos
 struct diskfree_t drive;
#endif/*_dos*/
 static unsigned int col;
 double nstop, nstep, delta_d, delta_v, offset;
 static double low_v[2], new_v[2], hi_v[2];
 static char buffer[MAX_LINE_LENGTH/2];
 char number[30];
 char *temp;
 char control_string[80]; 
 char type[11];
 char leader[80]; 
 char reply;
 double coefs[COEFLEN],bug;

 unsigned long free_space, needed_space;
 unsigned long input_pos, output_pos, write_pos;
/* 
   The program will;
   - change sample interval 
 */ 

 /* Memory restrictions require an upper limit on the number of input 
    samples.  This is the MAX_SAMPLES value defined at the start of this
    file.  It is purely a machine limitation.  If you are recompiling
    for a bigger machine you may increase it freely. */

 if ((1 + fabs((start - stop) / step)) > (double )(MAX_SAMPLES))
 {
  fprintf(stdout,"\nThis version of LAS REFORMAT is unable to handle more \n");
  fprintf(stdout,"than %d samples per curve.  Your file exceeds this limit.\n",
	  MAX_SAMPLES);
  fprintf(stdout,"Only the RESAMPLE option is affected however.  You can use\n");
  fprintf(stdout,"one of the other options to split the file into smaller ranges\n"); 
  return;

 }
 line = 0;
 do 
 {
  fprintf(stdout,"You have chosen to change the sample interval.\n"); 
  fprintf(stdout,"Your input file %s currently has this range:\n\n",infile); 
  fprintf(stdout," STARTING DEPTH : %lf\n",start);
  fprintf(stdout,"   ENDING DEPTH : %lf\n",stop);
  fprintf(stdout,"     DEPTH STEP : %lf\n\n\n\n\n\n",step);

 /* Ask the user for the new sample interval  */ 

 fprintf(stdout,"Please enter the new STEP value: "); 
 fflush(stdout);
 fgets(&(buffer[0]),80,stdin);
 sscanf(&(buffer[0])," %lf", &nstep); 
 
/* Check that the given step value is of the correct sign */ 
 
 entry = OK;
 if ((step * nstep) < (double )0)
 { 
  fprintf(stdout,"The step value you have given is a different sign from the\n"); 
  fprintf(stdout,"current value.  Please respecify or exit with a Ctrl C.\n");
  entry = BAD; 
  pause();
  clear_screen(); 
 }
 if(fabs(step-nstep)<.0001)
    {
    fprintf(stdout,"\nFATAL ERROR: The step value entered is the same  \n");
    fprintf(stdout,"as the step value of the input file.\n");
    fprintf(stdout,"This option has been disallowed because it corrupts the data\n");
    return;
    }
#ifdef undef
 if((fabs((start - stop) /nstep)) > 100000)
    {
    fprintf(stdout,"\nFATAL ERROR: This software was not designed to handle \n");
    fprintf(stdout,"  output files with more than 100,000 lines\n");
    return;
    }
#endif/*undef*/

 } while (entry != OK);

 
 /* Read through the file copying to the output until the depths are 
    reached. En route check for the stop & step values as they have to
    be reset and count the number of curves recorded in this file.      */
 fprintf(stdout,"Scanning line       "); 
 do
 { 
  if (fgetsup(buffer,MAX_LINE_LENGTH/2,ip) == NULL)
  { 
   fprintf(stdout,"Cannot read from input file. Run terminated\n");
   return;
  } 
  else
  { 
   line++;
   for (bksp = 1; bksp < 7; bksp++) 
    fprintf(stdout,"%c",8); 
   fprintf(stdout,"%ld",line);
   fflush (stdout);
   strset(type,'\0'); 
   sscanf(buffer, "%8s", type); 
 
   /* Check for step */ 
 
   if(strncmp(type,"STEP",4) == 0 )
   { 
    strset(leader,'\0'); 
    sscanf(buffer, "%[^-1234567890]", leader); 
    fprintf(op,"%s%lf:\n",leader,nstep);
   } 

   /* Check for stop */

   else if(strncmp(type,"STOP",4) == 0 )
   {
    strset(leader,'\0');
    sscanf(buffer, "%[^-1234567890]", leader);
    /*Calculate new stop as an even multiple of the new step*/
    nstop = start + (nstep * floor(fabs((stop-start) / nstep)));
    fprintf(op,"%s%lf:\n",leader,nstop);
   }

   /* Check for ~C section         */ 
 
   else 
   if (strncmp(type,"~C",2) == 0) 
   { 
 
   /* this is the curve counting block */ 
 
    fputs (buffer,op); 
    while (fgetsup (buffer,MAX_LINE_LENGTH/2,ip) != NULL)
    {
     line++;
     for (bksp = 1; bksp < 7; bksp++) 
      fprintf(stdout,"%c",8);
     fprintf(stdout,"%ld",line);
     fflush (stdout);
     strset(type,'\0');
     sscanf(buffer, "%8[^.]", type); 
     sscanf(type, "%s", type); 
     fputs (buffer,op); 
     if (type[0] == '~') 
      break; 
 
  /* Don't count comments or blank lines */ 
 
     if (type[0] == '#' || strlen(type) == 0 || strncmp(type,"DEPT",4) == 0) 
      continue; 
     else 
      curves++; 
    }                      /* end of while loop   */ 
   }                       /* end of curves block */
   else 
   {
    status=fputs(buffer,op);
    if ((status == EOF)||(status < 0))
    { 
     fprintf(stdout,"Cannot write to output file. Run terminated\n"); 
     return;
    } 
   }
  } 
 } 
 while (strncmp(type,"~A",2) != 0);
 
 first_data_line = line;

 /* If we are going to decimate the data, figure out the smoothing length required */

 if (fabs(step) < fabs(nstep))
 { 
  clear_screen();
  /* fflush(stdin); */
  fprintf(stdout,"A smoothing filter should be applied to the data prior to decimation.\n");
  fprintf(stdout," Do you want to apply the filter ? (Yes/No/Help) [Y]: ");
  fflush(stdout);

  do
  {
   bad = 1;
   /* fflush(stdin); */
   fgets(buffer,80,stdin);
   sscanf(buffer, "%c", &reply);

   switch(reply)
   {
    case 'h':
    case 'H':
	     fprintf(stdout," The filter supplied by this program is a triangular weighted\n");
	     fprintf(stdout," smoothing filter.  The default length is calculated based on\n");
	     fprintf(stdout," the decimation ratio such that the filter operator will span\n");
	     fprintf(stdout," two output samples.  The weights for the filter are based on\n");
	     fprintf(stdout," the length.  The numerator is the position within the filter\n");
	     fprintf(stdout," and the denominator is ((N+1)/2)**2 where N is the length in\n");
	     fprintf(stdout," samples.  Weights for a five point filter will therefore be\n"); 
	     fprintf(stdout," 1/9  2/9  3/9  2/9  1/9.  All weights sum to one.\n"); 
	     fprintf(stdout," \n");
	     fprintf(stdout," The reason for filtering is to prevent aliasing, that is the\n");
	     fprintf(stdout," effect of high frequencies in the input log which cannot be\n");
	     fprintf(stdout," properly represented in the output log appearing as noise.\n");
	     fprintf(stdout,"\n");
	     fprintf(stdout," Do you want to apply the filter ? (Yes/No/Help) [Y]: ");
             fflush(stdout);
	     break;
    case 10:                     /* 10 & 13 are the ascii codes for line */
    case 13: reply = 'Y';        /* feed and return. Allows the default  */
    case 'Y':
    case 'N':
    case 'y':
    case 'n':
     bad = 0;
   }
  }
  while(bad);
   
  if (reply == 'Y' || reply == 'y')
  {
   filter_reqd = 1;
   filter_length = (int )(fabs(nstep) / fabs(step));
   if (mod(filter_length, 2) == 0)
    filter_length++;
   if (filter_length == 1)
    filter_length = 3;
   /* fflush(stdin); */
   fprintf(stdout," Default filter length is %d samples.  Okay ? (Yes/No) [Y]:",filter_length);
   do
   {
    bad = 1;
    /*fflush(stdin);*/
    fgets(buffer,80,stdin);
    sscanf(buffer, "%c", &reply);

    switch(reply)
    {
     case 10:                     /* 10 & 13 are the ascii codes for line */
     case 13: reply = 'Y';        /* feed and return. Allows the default  */
     case 'Y':
     case 'N':
     case 'y':
     case 'n':
	     bad = 0;
    }
   }
   while(bad);
   
   if (reply == 'N' || reply == 'n')
   {
    fprintf(stdout," Enter filter length in samples :");
    fflush(stdout);
    fscanf(stdin, "%s", buffer);
    while(buffer[0] < '0' || buffer[0] > '9')
     fscanf(stdin, "%s", buffer);
    sscanf(buffer,"%d", &filter_length);
   }
   if (filter_length > COEFLEN)
   {
    fprintf(stdout,"WARNING: maximum filter length is 999 samples. Length set to 999\n");
    filter_length = 999;
   }
   if (filter_length == 1)
   {
    fprintf(stdout,"WARNING: filter length of 1 is equivalent to no filter. Length set to 3\n");
    filter_length = 3;
   }
   if (filter_length > 0)
    filter(filter_length, coefs);
   else
    filter_reqd = 0;
  }
  else
   filter_reqd = 0;
 } 
 
 
/*  Generate the set of data lines for the output file with only the depths
    filled in for now  */

    fprintf(stdout," Preparing output file space... ");
    for (bksp = 1; bksp < 33; bksp++)
       fprintf(stdout,"%c",8);
    fflush (stdout);
    output_pos = ftell(op);
    num_of_lines =(long)(1+fabs((start - stop) / nstep));
#ifdef _dos
    line_length = ((curves+1) * 11) + 2; /* CR-LF */
#else
    line_length = ((curves+1) * 11) + 1; /* CR */
#endif
    needed_space = (long)(num_of_lines) * (long)(line_length);
#ifdef _dos
    if (strchr(outfile,':') == NULL)
	output_drive=0; 
    else
    { 
     sscanf(outfile,"%1s",type);
     switch (toupper(type[0]))
     { 
     case 'A': 
	      output_drive=1; 
	      break; 
     case 'B':
	      output_drive=2; 
	      break; 
     case 'C': 
	      output_drive=3; 
	      break; 
     case 'D': 
	      output_drive=4; 
	      break; 
     case 'E': 
	      output_drive=5; 
	      break; 
     case 'F': 
	      output_drive=6;
	      break; 
     default: 
	      output_drive=0; 
     } 
    } 
    _dos_getdiskfree (output_drive, &drive); 
    free_space = (long)drive.avail_clusters * 
	    (long)drive.sectors_per_cluster *  (long)drive.bytes_per_sector; 
    if (needed_space > free_space) 
    { 
     fprintf(stdout,"\nERROR: %ld bytes are needed for the output. \n",needed_space); 
     fprintf(stdout,"        Only %ld bytes are available on the disk\n",free_space); 
     fprintf(stdout,"Run terminated\n"); 
     exit(9);
    }
#endif/*_dos*/
#ifdef _dos
    sprintf(control_string, " %%10.4lf%%%ds\n",line_length-13);
#else
    sprintf(control_string, " %%10.4lf%%%ds\n",line_length-12);
#endif
    for (i=0; i < num_of_lines; i++)
     fprintf(op, control_string, start + (i * nstep), " ");
   fprintf(stdout,"\n    numlines=%ld\n",num_of_lines);

 /* Now we have to resample the data. Load them a curve at a time. */

   input_pos = ftell(ip);
 for (current_curve = 1; current_curve <= curves; current_curve++)
 { 
  fseek(ip,input_pos,0);

  line = first_data_line;
  fprintf(stdout,"  Loading curve %3d...          ", current_curve);
  for (bksp = 1; bksp < 33; bksp++) 
    fprintf(stdout,"%c",8); 
  fflush (stdout);

  for (col = 0; col <(MAX_SAMPLES); col++)
  {
   if (fgets(buffer,MAX_LINE_LENGTH/2,ip) == NULL)
    break;
   else
   {
    line++;
    for (bksp = 1; bksp < 7; bksp++)
    fprintf(stdout,"%c",8);
    fprintf(stdout,"%ld",line);
    fflush (stdout);
 
    /* load the depth into row 0 if this is the first time through */

  if (current_curve == 1)
	{
	sscanf(buffer,"%s",soup);
	data[0][col]=atof(soup);

	}


    /* load the data for the current curve into row 1  */

    for (i = 0; i <= current_curve; i++)
    {
     sscanf(buffer,"%s",number);
     temp = strstr(buffer,number);
     strcpy(buffer,temp+strlen(number));
    }
    data[1][col]='\0';
    data[1][col]=atof(number);

    if (data[1][col] == 0.0)    /* if zero, check its really zero and not */
    {                           /* an error                               */
     for (i=0; i<length; i++)
     {
      if (isdigit(number[i]) != 0 || number[i] == '-' || number[i] =='.')
       continue;
      else
       {
       if(number[i]=='\x0')
	{
       /*	fprintf(stdout,"\n WARNING: encountered an x0 \n"); */
	 fflush(stdout);
	number[i]=' ';
	i=length;
	}
       else
	 {
	 fprintf(stdout,"\n WARNING: Non-numeric entry changed to blank\n");
	 fprintf(stdout," curve %d   data line %ld  \n",current_curve,col);
	  fflush(stdout);
	 number[i]=' ';

	 }

       }

     }

    }

   }

  }
  curve_length = col;

  /* Now the data is in array data, one trace per row, filter the traces
     to prevent aliasing, and then do the resampling.  */

  if (fabs(step) < fabs(nstep) && filter_reqd )
  { 
   fprintf(stdout,"  Filtering curve %3d...        ", current_curve);
   convolve(data[1], coefs, curve_length, filter_length);
   for (bksp = 1; bksp < 33; bksp++) 
    fprintf(stdout,"%c",8);
   fflush (stdout);
  } 
 

  fprintf(stdout,"  Outputting curve %3d...        ", current_curve);
  fflush(stdout);

  out_line = 0;
  fprintf(stdout,"line ");
  fflush(stdout);
   low_v[0] = start;    /* depth  same as data[0][0]*/
   low_v[1] = data[1][0];    /* first data point  */
   write_pos = output_pos + (current_curve * 11);
   fseek (op, write_pos, 0);
   fprintf(op, " %10.4lf",low_v[1]);
   i=0;
   write_pos = write_pos + line_length;
   fprintf(stdout,"%ld",++out_line);
   fprintf(stdout,"%c%c%c%c%c%c",8,8,8,8,8,8);
   fflush (stdout);



  /* Now get the new depth value  */

  new_v[0] = low_v[0] + nstep;
  /*i=0;*/
  /* Read ahead until a higher or equal value is found, figure out the
     interpolated values, write them out, call them the low values and
     start over until there's no more input.            */

  for (col=1; col <= (curve_length); col++)
  {

   hi_v[0] = data[0][col];
   hi_v[1] = data[1][col];


 shortcut: ;
   /*i=i+1;*/
   if (nstep > (double )0)
   { 
    if (hi_v[0] < (new_v[0]-.000001 ))
     continue;
   }
   else
   { 
    if (hi_v[0] > (new_v[0]+.000001 ))
     continue;
   }



   if (hi_v[0] == new_v[0])
   { 
     new_v[1] = hi_v[1];
     fseek (op, write_pos, 0);
     fprintf (op, " %10.4lf", new_v[1]);
     i=i+1;
     write_pos = write_pos + line_length;
     fprintf(stdout,"%6ld",++out_line);
     fprintf(stdout,"%c%c%c%c%c%c",8,8,8,8,8,8);
     fflush (stdout);
   } 
   else
   {
    offset = new_v[0] - low_v[0];    /*same as nstep*/
    delta_d = hi_v[0] - low_v[0];
    delta_v = hi_v[1] - low_v[1];
    if (delta_d == (double ) 0)
     fprintf(stdout,"ERROR: delta_d in RESAMP == 0\nIf repeatable call CWLS\n");
    new_v[1] = low_v[1] + ((delta_v / delta_d) * offset);
    fseek (op, write_pos, 0);
    fprintf(op, " %10.4lf",new_v[1]);
    i=i+1;
    write_pos = write_pos + line_length;
    fprintf(stdout,"%6ld",++out_line);
    fprintf(stdout,"%c%c%c%c%c%c",8,8,8,8,8,8);
    fflush (stdout);
    if(the_end==1)
    break;
   } 

  /* Make the low values equal to the new values */

   low_v[0] = new_v[0];
   low_v[1] = new_v[1];

  /* Reset the new depth */ 
 
   new_v[0] = low_v[0] + nstep;

  /* Check to see if we can reuse the current hi_value array */

   if (nstep > (double )0)
   {

   if(i>=num_of_lines-1)
   break;
    if ((new_v[0] <= hi_v[0])||(i==num_of_lines-2))
     goto shortcut;
     continue;

   }
   else
   {
   if(i>=num_of_lines-1)
   break;

    if ((new_v[0] >= hi_v[0])||(i==num_of_lines-2))
     goto shortcut;
     continue;

   } 
  } 
  fprintf(stdout,"%c%c%c%c%c",8,8,8,8,8);
  fprintf(stdout,"           ");
  for (bksp = 1; bksp < 44; bksp++)
    fprintf(stdout,"%c",8);
  fflush (stdout);
 } 
 fprintf(stdout,"\nREFORMAT(DEPTH RESAMPLE) COMPLETED\n");
 return;
}

void convolve(trace, filter, trace_length, filter_length)
double huge *trace, filter[];
int trace_length, filter_length;
{
 int i, j, index, half_filt_len;

 half_filt_len = filter_length / 2;

 fprintf(stdout,"%c%c%c",8,8,8);
 fflush (stdout);
 for (i=0; i < trace_length; i++)
 {
  fprintf(stdout,"< >%c%c%c",8,8,8);
  fflush (stdout);
  big_temp[i] = (double )0;
  for (j=half_filt_len; j > half_filt_len - filter_length; j--)
  {
   index = i - j;
   if (index < 0 || index > (trace_length - 1))
    continue;
   big_temp[i] = big_temp[i] + (trace[index] * filter[half_filt_len - j]);
  }
  fprintf(stdout," * %c%c%c",8,8,8);
  fflush (stdout);
 }

   /* Copy filtered trace from 1/2 filter length samples onward to avoid
      edge effects.  */

 for (i=half_filt_len; i < trace_length - half_filt_len; i++)
 {
  if (trace[i] != las_null)
     trace[i] = big_temp[i];
 }
 fprintf(stdout,"...");
}

void filter(length, coef)
double coef[];
int length;
{
 int denom, i;

 /* Ensure the filter length is odd, not even  */

  if (mod(length, 2) == 0)
   length++;

 /* The filter will be a simple triangular operator, with weights summing to one */

 denom = ((length + 1) / 2) * ((length + 1) / 2);

 for (i=0; i <= length/2; i++)
 {
  if (denom == 0)
   fprintf(stdout,"ERROR: denom in RESAMP-filter == 0\nIf repeatable call CWLS\n");
  coef[i] = (double)(i + 1) / (double)denom;
  coef[length - (i+1)] = coef[i];
 }
}



int mod(numerator, denom)
int numerator, denom;
{
 int temp;

 if (denom == 0)
  exit(0);
 temp = numerator/denom;
 return(numerator - (temp * denom));
}

