#include "local.h"

void unwrap() 
{
 int bksp, curves=0, skip=0, last, count;
 long line;
 char buffer[MAX_LINE_LENGTH];
 char number[80]; 
 char outstring[1280]; 
 char type[25]; 
 char *temp; 
 double depth;
 
 /* This program was written March 30th by Robin W. Winsor of Gulf Canada 
    Resources Limited.  It is intended for use with files written to the 
    C.W.L.S. Log File Standard. 
 
   The program will; 
   - unwrap a file from 80 col to 256 col. 
 */ 
 
 
 /* Read through the file header copying to the output until the depths are
    reached. En route check for the WRAP line as it must be flipped */ 
 
 line = 0L;
 fprintf(stdout,"Scanning line       "); 
 do 
 { 
  if (fgetsup (buffer,256,ip) == NULL)
  { 
   fprintf(stdout,"Cannot read from input file. Run terminated\n"); 
   return;  
  } 
  else 
  { 
   line++; 
   for (bksp = 1; bksp < 7; bksp++) 
    fprintf(stdout,"%c",8); 
   fprintf(stdout,"%6ld",line);
   if (line > 39163L)
   {
    bksp=1;
   }
   fflush (stdout);
 
   strset(type,'\0'); 
   sscanf(buffer, "%4s", type); 
   if(strncmp(type,"WRAP",4) == 0) 
   { 
 
  /* We must check that this file is indeed in wrap mode. If its not 
     tell the user and quit, otherwise output an updated line to reflect 
     the change we are about to make. 
 
     Scan the line for a Y or N */ 

    if (strchr(buffer,'Y') != NULL) 
    { 
      fputs(" WRAP.          NO: One line per depth step\n",op);
      skip = 1; 
    } 
    else 
    { 
     fprintf(stdout,"This file is not in wrap mode. The Version section\n"); 
     fprintf(stdout,"contains the following line:\n %s",buffer); 
     return; 
    } 
   } 
 
  if (strncmp(type,"~C",2) == 0) 
  { 
    /* this is the curve counting block */ 
 
    fputs (buffer,op); 
    while (fgetsup (buffer,256,ip) != NULL)
    { 
     line++; 
     for (bksp = 1; bksp < 7; bksp++) 
      fprintf(stdout,"%c",8); 
     fprintf(stdout,"%6ld",line);
     strset(type,'\0'); 
     sscanf(buffer, "%4s", type); 
     if (type[0] == '~') 
      break; 
 
     fputs (buffer,op); 
 
   /* Don't count the comments or blank lines */ 
 
     if (type[0] == '#' || strlen(type) == 0) 
      continue; 
     else 
      curves++; 
    } 
   }                       /* end of curves block */ 
 
 
   if (skip == 0) 
   { 
    status=fputs(buffer,op);
    if (status == EOF)
    {
     fprintf(stdout,"Cannot write to output file. Run terminated\n"); 
     exit(9); 
    } 
   } 
   else 
    skip = 0; 
  } /* end of the "if I cant read else..."   */ 
 } 
  while (type[0] != '~' || type[1] != 'A');
 
/* Now unwrap the data...                                          */ 
 
  last = NO; 
  count = 0L;
  strset(buffer,' '); 
  strset (outstring, '\0'); 
  while (fgets (buffer,80,ip) != NULL) 
  { 
   line++; 
   for (bksp = 1; bksp < 7; bksp++) 
    fprintf(stdout,"%c",8); 
   fprintf(stdout,"%6ld",line);
   fflush (stdout);
   while (count < curves) 
   { 
    while((sscanf(buffer,"%s",number)) == 1) 
    { 
     if (count == 0) 
     { 
      depth = atof(number); 
      if (depth == stop) 
	last = YES; 
     } 
     count++; 
     temp = strstr(buffer,number); 
     strcpy(buffer,temp+strlen(number)); 
     strcat(outstring,number); 
     strcat(outstring,"   "); 
    } 
    if((strlen(outstring)) > MAX_LINE_LENGTH) 
    { 
     fprintf(stdout,"Unwrap gives a line length greater than the limit of %d.\n",MAX_LINE_LENGTH); 
     fprintf(stdout,"Line skipped for depth %7s\n",outstring); 
    } 
    if (count < curves) 
    { 
      line++; 
      if(fgets (buffer,80,ip) == NULL) 
      { 
       fprintf(stdout,"\nNon-fatal error encountered while unwrapping file.\n"); 
       return; 
      } 
    } 
   } 
   fprintf(op,"%s\n",outstring);
   if (last == YES) 
    return; 
   strset (outstring, '\0'); 
   count = 0; 
   } 
   fprintf(stdout,"\nREFORMAT(UNWRAP) COMPLETED\n"); 
}
